import Web3 = require('web3');
import { Account } from 'web3/types';
export declare class Erc780Options {
    gasMultiplier?: number;
    gasLimit?: number;
    gasPriceMax?: number;
    ABI?: any[];
}
export declare class Erc780 {
    private _web3;
    private _ethereumProvider;
    private _contractAddress;
    private _ABI;
    private _contract;
    private _account;
    private _gasMultiplier;
    private _gasLimit;
    private _gasPriceMax;
    private _transactionCount;
    readonly ethereumProvider: string;
    readonly contractAddress: string;
    readonly web3: Web3;
    readonly account: Account;
    constructor(ethereumProvider: string, contractAddress: string, privateKey?: string, options?: Erc780Options);
    private _pickDefault;
    private _connectWeb3;
    setClaim: (subject: any, key: any, value: any) => Promise<string>;
    setSelfClaim: (key: any, value: any) => Promise<string>;
    removeClaim: (issuer: any, subject: any, key: any) => Promise<string>;
    getClaim: (issuer: string, subject: string, key: string) => Promise<string>;
    private _sendSignedTransaction;
}
export default Erc780;
