"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class StringEx {
    static createArray(json) {
        return json;
    }
}
exports.StringEx = StringEx;
class RecordEx {
    static createArray(json) {
        return json;
    }
}
exports.RecordEx = RecordEx;
class SsifCommitment {
    static create(json) {
        if (json == null) {
            return null;
        }
        let obj = new SsifCommitment();
        obj = JSON.parse(JSON.stringify(json));
        return obj;
    }
}
exports.SsifCommitment = SsifCommitment;
class SsifStatements {
    static create(json) {
        if (json == null) {
            return null;
        }
        let obj = new SsifStatements();
        obj = JSON.parse(JSON.stringify(json));
        return obj;
    }
}
exports.SsifStatements = SsifStatements;
class SsifSpo {
    constructor() {
        this['@context'] = undefined;
        this['@type'] = undefined;
        this.statements = undefined;
        this.commitment = undefined;
    }
    static create(json) {
        if (json == null) {
            return null;
        }
        const obj = new SsifSpo();
        obj['@context'] = StringEx.createArray(json['@context']);
        obj['@type'] = json['@type'];
        obj.statements = SsifStatements.create(json.statements);
        obj.commitment = SsifCommitment.create(json.commitment);
        return obj;
    }
    static createArray(json) {
        if (json == null) {
            return null;
        }
        const array = new Array();
        for (const obj of json) {
            array.push(SsifSpo.create(obj));
        }
        return array;
    }
}
exports.SsifSpo = SsifSpo;
class SsifTrustedAttestor {
    constructor() {
        this.type = undefined;
        this.name = undefined;
    }
    static create(json) {
        if (json == null) {
            return null;
        }
        const obj = new SsifTrustedAttestor();
        obj.type = json.type;
        obj.name = json.name;
        return obj;
    }
    static createArray(json) {
        if (json == null) {
            return null;
        }
        const array = new Array();
        for (const obj of json) {
            array.push(SsifTrustedAttestor.create(obj));
        }
        return array;
    }
}
exports.SsifTrustedAttestor = SsifTrustedAttestor;
class SsifAttest {
    constructor() {
        this.iri = undefined;
        this.value = undefined;
    }
    static create(json) {
        if (json == null) {
            return null;
        }
        const obj = new SsifAttest();
        obj.iri = json.iri;
        obj.value = json.value;
        return obj;
    }
}
exports.SsifAttest = SsifAttest;
class SsifAttestationIssuerSpo extends SsifSpo {
    static create(json) {
        if (json == null) {
            return null;
        }
        const obj = new SsifAttestationIssuerSpo();
        obj['@context'] = json['@context'];
        obj['@type'] = json['@type'];
        obj.statements = json.statements;
        obj.commitment = json.commitment;
        return obj;
    }
}
exports.SsifAttestationIssuerSpo = SsifAttestationIssuerSpo;
class SsifAttestationSpo extends SsifSpo {
    static create(json) {
        if (json == null) {
            return null;
        }
        const obj = new SsifAttestationSpo();
        return obj;
    }
}
exports.SsifAttestationSpo = SsifAttestationSpo;
/*
export class SsifRevoke implements interfaces.ISsifRevoke {
  iri: string = undefined;

  public static create(json: interfaces.ISsifRevoke): interfaces.ISsifRevoke {
    if (json == null) {
      return null;
    }
    const obj: interfaces.ISsifRevoke = new SsifRevoke();
    obj.iri = json.iri;
    return obj;
  }
}
*/
class SsifText {
    constructor() {
        this.langcode = undefined;
        this.text = undefined;
    }
    static create(json) {
        if (json == null) {
            return null;
        }
        const obj = new SsifText();
        obj.langcode = json.langcode;
        obj.text = json.text;
        return obj;
    }
    static createArray(json) {
        if (json == null) {
            return null;
        }
        const array = new Array();
        for (const obj of json) {
            array.push(SsifText.create(obj));
        }
        return array;
    }
}
exports.SsifText = SsifText;
class SsifVerifyRequest {
    constructor() {
        this.iri = undefined;
        this.value = undefined;
        this.trustedAttestor = undefined;
    }
    static create(json) {
        if (json == null) {
            return null;
        }
        const obj = new SsifVerifyRequest();
        obj.iri = json.iri;
        obj.value = json.value;
        obj.trustedAttestor = SsifTrustedAttestor.createArray(json.trustedAttestor);
        return obj;
    }
}
exports.SsifVerifyRequest = SsifVerifyRequest;
class SsifAttestation {
    constructor() {
        this.name = undefined;
        this.spo = undefined;
    }
    static create(json) {
        if (json == null) {
            return null;
        }
        const obj = new SsifAttestation();
        obj.name = json.name;
        obj.spo = SsifAttestationSpo.create(json.spo);
        return obj;
    }
    static createArray(json) {
        if (json == null) {
            return null;
        }
        const array = new Array();
        for (const obj of json) {
            array.push(SsifAttestation.create(obj));
        }
        return array;
    }
}
exports.SsifAttestation = SsifAttestation;
class SsifAttestor {
    constructor() {
        this.name = undefined;
        this.ethereumAdress = undefined;
        this.logo = undefined;
        this.infoUrl = undefined;
        this.pssifUrl = undefined;
        this.texts = undefined;
    }
    static create(json) {
        if (json == null) {
            return null;
        }
        const obj = new SsifAttestor();
        obj.name = json.name;
        obj.ethereumAdress = json.ethereumAdress;
        obj.logo = json.logo;
        obj.infoUrl = json.infoUrl;
        obj.pssifUrl = json.pssifUrl;
        obj.texts = SsifText.createArray(json.texts);
        return obj;
    }
    static createArray(json) {
        if (json == null) {
            return null;
        }
        const array = new Array();
        for (const obj of json) {
            array.push(SsifAttestor.create(obj));
        }
        return array;
    }
}
exports.SsifAttestor = SsifAttestor;
class SsifCategory {
    constructor() {
        this.name = undefined;
        this.texts = undefined;
    }
    static create(json) {
        if (json == null) {
            return null;
        }
        const obj = new SsifCategory();
        obj.name = json.name;
        obj.texts = SsifText.createArray(json.texts);
        return obj;
    }
    static createArray(json) {
        if (json == null) {
            return null;
        }
        const array = new Array();
        for (const obj of json) {
            array.push(SsifCategory.create(obj));
        }
        return array;
    }
}
exports.SsifCategory = SsifCategory;
class SsifMeta {
    constructor() {
        this.attestationIssuer = undefined;
    }
    static create(json) {
        if (json == null) {
            return null;
        }
        const obj = new SsifMeta();
        obj.attestationIssuer = SsifAttestationIssuerSpo.create(json.attestationIssuer);
        return obj;
    }
}
exports.SsifMeta = SsifMeta;
class SsifPredicate {
    constructor() {
        this.iri = undefined;
        this.datatype = undefined;
        this.texts = undefined;
        this.categoryName = undefined;
        this.attestorNames = undefined;
    }
    static create(json) {
        if (json == null) {
            return null;
        }
        const obj = new SsifPredicate();
        obj.iri = json.iri;
        obj.datatype = json.datatype;
        obj.texts = SsifText.createArray(json.texts);
        obj.categoryName = json.categoryName;
        obj.attestorNames = json.attestorNames;
        return obj;
    }
    static createArray(json) {
        if (json == null) {
            return null;
        }
        const array = new Array();
        for (const obj of json) {
            array.push(SsifPredicate.create(obj));
        }
        return array;
    }
}
exports.SsifPredicate = SsifPredicate;
class SsifRequest {
    constructor() {
        this.attest = undefined;
        this.revoke = undefined;
        this.verifyRequest = undefined;
    }
    static create(json) {
        if (json == null) {
            return json;
        }
        const obj = new SsifRequest();
        obj.attest = RecordEx.createArray(json.attest);
        obj.revoke = json.revoke;
        obj.verifyRequest = json.verifyRequest;
        return obj;
    }
}
exports.SsifRequest = SsifRequest;
// TODO Check usage
class SsifAttestorInformation {
    constructor() {
        this.name = undefined;
        this.ethereumAdress = undefined;
        this.logo = undefined;
        this.infoUrl = undefined;
        this.ssifUrl = undefined;
        this.texts = undefined;
        this.responsePredicates = undefined;
    }
    static create(json) {
        if (json == null) {
            return null;
        }
        const obj = new SsifAttestorInformation();
        obj.name = json.name;
        obj.ethereumAdress = json.ethereumAdress;
        obj.logo = json.logo;
        obj.infoUrl = json.infoUrl;
        obj.ssifUrl = json.ssifUrl;
        obj.texts = SsifText.createArray(json.texts);
        obj.responsePredicates = SsifPredicate.createArray(json.responsePredicates);
        return obj;
    }
}
exports.SsifAttestorInformation = SsifAttestorInformation;
// TODO Check usage
class SsifConfiguration {
    constructor() {
        this.blockchain = undefined;
        this.privateKey = undefined;
        this.categories = undefined;
        this.sessionTimeout = undefined;
        this.gasMultiplier = undefined;
        this.gasLimit = undefined;
        this.gasPriceMax = undefined;
    }
    static create(json) {
        if (json == null) {
            return null;
        }
        const obj = new SsifConfiguration();
        obj.blockchain = json.blockchain;
        obj.privateKey = json.privateKey;
        obj.categories = SsifCategory.createArray(json.categories);
        obj.gasMultiplier = json.gasMultiplier;
        obj.gasLimit = json.gasLimit;
        obj.gasPriceMax = json.gasPriceMax;
        return obj;
    }
}
exports.SsifConfiguration = SsifConfiguration;
class SsifCreateRequest extends SsifRequest {
    constructor() {
        super(...arguments);
        this.publicExtendedKey = undefined;
    }
    static create(json) {
        if (json == null) {
            return null;
        }
        const obj = new SsifCreateRequest();
        obj.publicExtendedKey = json.publicExtendedKey;
        obj.attest = json.attest;
        obj.revoke = json.revoke;
        obj.verifyRequest = json.verifyRequest;
        return obj;
    }
}
exports.SsifCreateRequest = SsifCreateRequest;
class SsifCreateRequestAnonymous extends SsifRequest {
    static create(json) {
        if (json == null) {
            return json;
        }
        const obj = new SsifCreateRequestAnonymous();
        return obj;
    }
}
exports.SsifCreateRequestAnonymous = SsifCreateRequestAnonymous;
class SsifResult {
    constructor() {
        this.verified = undefined;
        this.revoked = undefined;
        this.attested = undefined;
        this.meta = undefined;
    }
    static create(json) {
        if (json == null) {
            return null;
        }
        const obj = new SsifResult();
        obj.verified = SsifSpo.createArray(json.verified);
        obj.revoked = SsifSpo.createArray(json.revoked);
        obj.attested = SsifSpo.createArray(json.attested);
        obj.meta = SsifMeta.create(json.meta);
        return obj;
    }
}
exports.SsifResult = SsifResult;
class SsifSessionRequest {
    constructor() {
        this.meta = undefined;
        this.template = undefined;
    }
    static create(json) {
        if (json == null) {
            return null;
        }
        const obj = new SsifSessionRequest();
        obj.meta = SsifMeta.create(json.meta);
        obj.template = JSON.parse(JSON.stringify(json.template));
        // todo
        // obj.template = RecordEx.createArray(json.template);
        return obj;
    }
}
exports.SsifSessionRequest = SsifSessionRequest;
class SsifSessionResponse {
    constructor() {
        this.attestations = undefined;
    }
    static create(json) {
        if (json == null) {
            return null;
        }
        const obj = new SsifSessionResponse();
        obj.attestations = JSON.parse(JSON.stringify(json.attestations));
        return obj;
    }
}
exports.SsifSessionResponse = SsifSessionResponse;
//# sourceMappingURL=models.js.map