import { SsifSessionRequest, SsifSessionResponse, SsifCreateRequest, SsifCreateRequestAnonymous, SsifMeta, SsifResult, SsifConfiguration } from './models';
export declare class SsifApi {
    private _attestor;
    private _sessions;
    private _context;
    private _jsonLdAttestation;
    meta: SsifMeta;
    context: string[];
    static generateSessionId(): string;
    constructor(ethereumProvider: string, contractAddress: string, privateKey?: string, config?: SsifConfiguration);
    getSchema(): Promise<object>;
    addTrustEcdsaKoblitzSignature2016: (key: any) => void;
    addTrustSSIFEthereumHash2017: (contract: any) => void;
    addTrustSsifErc780Hash2018: (issuer: any) => void;
    startSessionAutonomous: (ssifCreateRequest: SsifCreateRequest) => Promise<any>;
    startSession: (sessionId: string, ssifCreateRequest: SsifCreateRequest) => Promise<any>;
    startSessionFirstContact: (sessionId: string, ssifCreateRequest: SsifCreateRequestAnonymous) => Promise<any>;
    getSession: (sessionId: string) => Promise<SsifSessionRequest>;
    postSession: (sessionId: string, response: SsifSessionResponse) => Promise<SsifResult>;
    private updateAttestations;
}
export default SsifApi;
export * from './models';
